/* PPLite: a lightweight library for convex polyhedra derived from PPL.
   Copyright (C) 2018 Enea Zaffanella <enea.zaffanella@unipr.it>

This file is part of PPLite.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "pplite_test.hh"

bool
test01() {
  Linear_Expr e1, e2;
  Integer z;
  e1.scalar_prod_add(z, e2);
  return z == 0;
}

bool
test02() {
  Linear_Expr e1 = Var(1), e2 = Var(2);
  Integer z;
  e1.scalar_prod_add(z, e2);
  return z == 0;
}

bool
test03() {
  Linear_Expr e1 = Var(1), e2 = Var(2);
  Integer z = 1234;
  e1.scalar_prod_add(z, e2);
  return z == 1234;
}

bool
test04() {
  Linear_Expr e1 = 3*Var(1) - 2*Var(2);
  Integer z = 0;
  e1.scalar_prod_add(z, Var(2));
  return z == -2;
}

BEGIN_MAIN
  DO_TEST(test01);
  DO_TEST(test02);
  DO_TEST(test03);
  DO_TEST(test04);
END_MAIN
